<template>
  <div class="subscription">
    <v-row
      :class="[
        { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
      ]"
    >
      <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
        <menu-bar />
      </v-col>
      <v-col>
        <v-row
          :class="[
            { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
            { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
          ]"
        >
          <v-col>
            <h1 class="font-syne-bold">
              {{ $t('dashboard.menu.SUBSCRIPTION') }}
            </h1>
          </v-col>
        </v-row>
        <v-form ref="paymentForm" lazy-validation @submit.prevent>
          <v-row
            :class="[
              {
                'pl-0 pr-0': $vuetify.breakpoint.smAndDown,
              },
              { 'pl-16 pr-0 pb-5': $vuetify.breakpoint.mdAndUp },
            ]"
          >
            <v-col cols="12" md="8">
              <!-- CURRENT SUBSCRIPTION -->
              <div
                v-if="
                  !planDetails ||
                    Object.keys(planDetails).length === 0
                "
              >
                <p
                  class="
                                        font-14 font-metropolis-regular
                                        text-white
                                    "
                >
                  {{ $t('common.noSubscription') }}
                </p>

                <!-- SHOW LOADER -->
                <v-col v-if="plans.length === 0" cols="12">
                  <v-row>
                    <v-col
                      v-for="n in 2"
                      :key="'loader-' + n"
                      cols="6"
                    >
                      <v-skeleton-loader
                        class="pt-2"
                        :loading="dataLoading"
                        max-width="150"
                        type="text"
                      />

                      <v-skeleton-loader
                        :loading="dataLoading"
                        max-width="100"
                        type="text"
                      />

                      <v-skeleton-loader
                        :loading="dataLoading"
                        max-width="120"
                        type="text"
                      />

                      <v-skeleton-loader
                        :loading="dataLoading"
                        max-width="100"
                        type="text"
                      />

                      <v-skeleton-loader
                        :loading="dataLoading"
                        max-width="100"
                        type="text"
                      />

                      <v-skeleton-loader
                        :loading="dataLoading"
                        max-width="100"
                        type="text"
                      />

                      <v-skeleton-loader
                        :loading="dataLoading"
                        max-width="100"
                        type="text"
                      />
                    </v-col>
                  </v-row>
                </v-col>
                <v-row v-else>
                  <v-col
                    v-for="(plan, p) in plans"
                    :key="'plan-' + p"
                    v-model="form.plan.value"
                    cols="12"
                    md="6"
                  >
                    <v-row class="plan">
                      <v-col cols="12" class="d-flex justify-center">
                        <div class="planType-content">
                          <div class="planType-container">
                            <p class="planType-title mb-1 font-syne-bold uppercase">
                              {{ plan.name }}
                            </p>
                          </div>
                          <div class="info-container">
                            <p v-if="plan.featured == 1" class="info-title">
                              {{ $t('home.bestValuePlan') }} 
                            </p>
                            <p v-else class="info-subtitle">
                              <b>{{ plan.name }}</b>
                            </p>
                            <p class="info-subtitle" v-html="plan.info" />
                          </div>
                          <div class="d-flex justify-center">
                            <v-btn
                              class="mt-5 mx-5 lowercase br-0 pl-10 pr-10 plan-btn"
                              color="black"
                              :value="plan.stripe_plan"
                              @click="selectPlan(p, plan.stripe_plan)"
                            >
                              <span>
                                {{ currencyName }}
                                {{ plan.amount }}
                                <span class="trial-text">{{ $t('home.trial') }}</span> 
                              </span>
                            </v-btn>
                          </div>
                        </div>
                      </v-col>
                    </v-row>
                  </v-col>
                </v-row>

                <!-- <v-col v-else>
                                    <v-radio-group
                                        v-model="form.plan.value"
                                        row
                                        :rules="[requiredRules]"
                                    >
                                        <v-row
                                            v-for="(plan, p) in plans"
                                            :key="'plan-' + p"
                                            class="align-start"
                                        >
                                            <v-radio
                                                :key="'radio-plan-' + p"
                                                :value="plan.stripe_plan"
                                                color="badge"
                                                @click="selectPlan(p)"
                                            >
                                                <template v-slot:label>
                                                    <v-col
                                                        md="12"
                                                        cols="12"
                                                        class="
                                                            form-field
                                                            font-metropolis-regular
                                                        "
                                                    >
                                                        <h3
                                                            class="
                                                                font-syne-bold
                                                                mb-0
                                                                text-white
                                                            "
                                                        >
                                                            {{ plan.name }}
                                                        </h3>

                                                        <h3
                                                            class="
                                                                font-syne-bold
                                                                price
                                                                text-white
                                                            "
                                                        >
                                                            {{ currencyName }}
                                                            {{ plan.amount }}
                                                            <span
                                                                class="duration"
                                                                >/{{
                                                                    plan.interval
                                                                }}</span
                                                            >
                                                        </h3>
                                                        <div
                                                            class="mt-5 mb-5"
                                                            v-html="
                                                                plan.description
                                                            "
                                                        ></div>
                                                    </v-col>
                                                </template>
                                            </v-radio>
                                        </v-row>
                                    </v-radio-group>
                                </v-col> -->
              </div>
              <div v-else>
                <h3
                  v-if="planDetails"
                  class="font-syne-bold mb-0 text-white"
                >
                  {{ planDetails.name }}
                </h3>

                <h3
                  v-if="planDetails"
                  class="font-syne-bold price text-white"
                >
                  {{ currencyName }} {{ planDetails.amount }}
                  <span
                    class="duration"
                  >{{ planDetails.amount ? '/' : ''
                  }}{{ planDetails.interval }}</span>
                </h3>
                <div
                  v-if="planDetails"
                  class="mt-5 mb-5"
                  v-html="planDetails.description"
                />
              </div>
            </v-col>

            <!-- AFTER SUBSCRIBED -->
            <v-col
              v-if="
                planDetails &&
                  Object.keys(planDetails).length > 0
              "
              cols="12"
              md="3"
              class="text-right"
            >
              <v-btn
                :block="$vuetify.breakpoint.smAndDown"
                color="badge"
                class="
                                    lowercase
                                    br-0
                                    pl-10
                                    pr-10
                                    font-syne-bold
                                "
                :loading="isLoading"
                :disabled="isButtonDisabled"
                @click="
                  goToPage(
                    menus.SUBSCRIPTION.sub.SUBSCRIPTIONEDIT
                      .id
                  )
                "
              >
                {{ $t('buttons.changePlanBtn') }}
              </v-btn>
            </v-col>

            <!-- BEFORE SUBSCRIBE -->
            <v-col v-else cols="12" md="4" class="text-left">
              <v-row v-if="form.plan.value">
                <v-col>
                  <h3 class="font-syne-bold">
                    {{ $t('orders.orderSummary') }}
                  </h3>
                </v-col>
              </v-row>
              <v-row v-if="form.plan.value">
                <v-col cols="8">
                  <p class="font-14 font-syne-bold mb-1">
                    {{ plans[selectedPlan].name }}
                  </p>
                  <p class="font-12 text-grey">
                    {{ $t('common.pauseCancelAnytime') }}
                  </p>
                </v-col>
                <v-col cols="4">
                  <p
                    class="
                                            font-14 font-metropolis-regular
                                            text-grey
                                            mb-1
                                        "
                  >
                    {{ currencyName
                    }}{{ plans[selectedPlan].amount }}/{{
                      plans[selectedPlan].interval
                    }}
                  </p>
                </v-col>
              </v-row>
              <v-divider v-if="form.plan.value" />
              <v-row v-if="form.plan.value">
                <v-col>
                  <h3 class="font-syne-bold">
                    {{ $t('orders.orderDetails') }}
                  </h3>
                </v-col>
              </v-row>
              <v-row v-if="form.plan.value">
                <v-col cols="8">
                  <p class="font-14 font-syne-bold mb-1">
                    {{ plans[selectedPlan].name }}
                  </p>
                </v-col>
                <v-col cols="4" class="text-right">
                  <p
                    class="
                                            font-14 font-metropolis-regular
                                            text-red
                                            mb-1
                                        "
                  >
                    {{ currencyName }}
                    {{ plans[selectedPlan].amount }}
                  </p>
                </v-col>
              </v-row>
              <v-divider v-if="coupons" />
              <v-row v-if="coupons">
                <v-col cols="8">
                  <p class="font-14 font-syne-bold mb-1">
                    {{ $t('common.promo') }}
                  </p>
                </v-col>
                <v-col
                  v-if="coupons.amount_off"
                  cols="4"
                  class="text-right"
                >
                  <p
                    class="
                                            font-14 font-metropolis-regular
                                            text-red
                                            mb-1
                                        "
                  >
                    {{ currencyName }}
                    {{ coupons.amount_off }}
                  </p>
                </v-col>
                <v-col
                  v-if="coupons.percent_off"
                  cols="4"
                  class="text-right"
                >
                  <p
                    class="
                                            font-14 font-metropolis-regular
                                            text-red
                                            mb-1
                                        "
                  >
                    {{ coupons.percent_off }} {{ '%' }}
                  </p>
                </v-col>
              </v-row>
              <v-divider v-if="form.plan.value" />
              <v-row v-if="form.plan.value">
                <v-col cols="8">
                  <p class="font-14 font-syne-bold mb-1">
                    {{ $t('common.total') }}
                  </p>
                </v-col>
                <v-col
                  v-if="
                    !coupons.amount_off &&
                      !coupons.percent_off
                  "
                  cols="4"
                  class="text-right"
                >
                  <p
                    class="
                                            font-14 font-metropolis-regular
                                            text-red
                                            mb-1
                                        "
                  >
                    {{ currencyName }}
                    {{ plans[selectedPlan].amount }}
                  </p>
                </v-col>
                <v-col
                  v-if="coupons.amount_off"
                  cols="4"
                  class="text-right"
                >
                  <p
                    class="
                                            font-14 font-metropolis-regular
                                            text-red
                                            mb-1
                                        "
                  >
                    {{ currencyName }}
                    {{ price }}
                  </p>
                </v-col>
                <v-col
                  v-if="coupons.percent_off"
                  cols="4"
                  class="text-right"
                >
                  <p
                    class="
                                            font-14 font-metropolis-regular
                                            text-red
                                            mb-1
                                        "
                  >
                    {{ currencyName }}
                    {{ price }}
                  </p>
                </v-col>
              </v-row>
              <v-row 
                :class="payment? 'd-block' : 'd-none'"
              >
                <v-col>
                  <h3 class="font-syne-bold">
                    {{ $t('orders.addPaymentMethod') }}
                  </h3>
                </v-col>
                <v-col cols="12">
                  <div id="card-wrapper">
                    <div id="card-element">
                      <!-- A Stripe Element will be inserted here. -->
                    </div>

                    <!-- Used to display form errors. -->
                    <div id="card-errors" role="alert" />
                  </div>
                </v-col>
              </v-row>
              <v-row v-if="form.plan.value">
                <v-col
                  cols="12"
                  class="d-flex align-center justify-end"
                >
                  <v-text-field
                    v-model="promo"
                    hide-details="auto"
                    dense
                    filled
                    solo
                    color="badge"
                    class="
                                            white-bg
                                            text-grey
                                            font-metropolis-regular
                                        "
                    :label="$t('cart.promoCode')"
                    type="text"
                    :loading="promoLoad"
                    :disabled="promoDisabled"
                  />
                  <v-btn
                    class="redeemBtn"
                    text
                    color="black"
                    :loading="promoLoad"
                    :disabled="promoDisabled"
                    @click="redeemPromoCode"
                  >
                    {{ $t('buttons.redeemBtn') }}
                  </v-btn>
                </v-col>
                <v-col v-if="promoApply" cols="12">
                  <v-chip>{{ promo }}</v-chip>
                  <v-btn
                    icon
                    x-small
                    @click="removePromoCode"
                  >
                    <v-icon>mdi-close</v-icon>
                  </v-btn>
                </v-col>
              </v-row>
              <v-row v-if="form.plan.value">
                <v-col cols="12" class="pa-0">
                  <v-btn
                    class="
                                            mt-5
                                            lowercase
                                            br-0
                                            pl-10
                                            pr-10
                                            font-syne-bold
                                        "
                    color="badge"
                    block
                    :loading="isLoading"
                    :disabled="isButtonDisabled"
                    @click="validateForm"
                  >
                    {{
                      $t('buttons.subscribePlanBtn')
                    }}
                  </v-btn>
                </v-col>
              </v-row>
            </v-col>
          </v-row>

          <!-- PAYMENT -->
          <!-- <v-row
                        v-show="
                            (!planDetails ||
                                Object.keys(planDetails).length === 0) &&
                            form.plan.value !== ''
                        "
                        :class="[
                            { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                            {
                                'pl-16 pr-16 pb-16':
                                    $vuetify.breakpoint.mdAndUp,
                            },
                        ]"
                    >
                        <v-col cols="12">
                            <h1 class="font-syne-bold">
                                {{ $t('orders.addPaymentMethod') }}
                            </h1>
                        </v-col>
                        <v-col cols="12" md="8">
                            <div id="card-wrapper">
                                <div id="card-element"> -->
          <!-- A Stripe Element will be inserted here. -->
          <!-- </div> -->

          <!-- Used to display form errors. -->
          <!-- <div id="card-errors" role="alert" />
                            </div>
                        </v-col>
                    </v-row> -->
        </v-form>
      </v-col>
    </v-row>
  </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.SUBSCRIPTION'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        planDetails: 'subscription/getPlanDetails',
        planName: 'subscription/getPlan',
        stripeClientSecret: 'cart/getStripeClientSecret',
        currencyName: 'currency/getCurrencyName',
    }),
})
export default class Subscription extends Vue {
    // Data
    $refs!: { paymentForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    menus!: any
    selectedPage: Number = 4 // subscription
    selectedPlan!: number
    stripeClientSecret!: String
    dataLoading: Boolean = true
    isButtonDisabled = true
    isLoading = false
    formHasErrors: Boolean = true
    stripe: any = ''
    elements: any = ''
    plans: any = []
    coupons: any = ''
    price: Number = 0
    promoLoad: boolean = false
    promoDisabled: boolean = false
    promo: string = ''
    promoApply: boolean = false
    initiatePayment: string = ''
    form: { [key: string]: any } = {
        plan: {
            value: '',
            error: null,
            requestKey: null,
        },
    }

    payment: Boolean = false
    card: any

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    // Method
    redeemPromoCode() {
        if (this.promo) {
            this.getCoupons(this.promo)
            this.promoDisabled = true
            this.promoApply = true
        }
    }

    removePromoCode() {
        if (this.promo) {
            this.promo = ''
            this.promoDisabled = false
            this.promoApply = false
            this.coupons = ''
        }
    }

    selectPlan(p: number, plan: string) {
        this.selectedPlan = p
        this.form.plan.value = plan
        
        setTimeout(() => {
            this.card.mount('#card-element')
            this.payment = true
        },500);
    }

    submitSubscription(payment: any) {
        this.$api.subscription
            .subscribe(this.form.plan.value, payment, this.promo)
            .then(() => {
                this.isButtonDisabled = false
                this.$store.dispatch(
                    'subscription/setPlan',
                    this.form.plan.value
                )

                // Get subscription
                this.getUserSubscription()
            })
            .catch((error) => {
                this.isButtonDisabled = false
                this.isLoading = false
                if (error.response.status === 422) {
                    const errorMessage =
                        'errors' in error.response.data &&
                        'coupon' in error.response.data.errors
                            ? this.$t('notification.subscription.promo.invalid')
                            : error.response.data.message

                    // Display subscription error message
                    const val = {
                        text: errorMessage,
                        color: 'red',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                } else {
                    // Display subscription error message
                    const val = {
                        text: this.$t('notification.subscription.failed'),
                        color: 'red',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                }
            })
    }

    getUserSubscription() {
        this.$api.user
            .subscriptions()
            .then((result) => {
                this.$store.dispatch('subscription/setPlan', result.data)

                // Display success subscription message
                const val = {
                    text: this.$t('notification.subscription.success'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                // Redirect back to dashboard
                this.$router.push('/browse')
            })
            .catch((error) => {
                if (error.response.status === 422) {
                    // Get errors object
                    // const errors = error.response.data.errors
                }
            })
    }

    goToPage(id: Number) {
        switch (id) {
            case this.menus.SUBSCRIPTION.sub.SUBSCRIPTIONEDIT.id:
                this.$router.push(
                    this.menus.SUBSCRIPTION.sub.SUBSCRIPTIONEDIT.path
                )
                break

            default:
                this.$router.push('/')
                break
        }
    }

    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.paymentForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        this.isButtonDisabled = true
        this.isLoading = true
        if (this.promo && !this.promoApply) {
            // Display promo code reminder message
            const val = {
                text: this.$t('notification.subscription.promo.redeem'),
                color: 'white',
                icon: 'mdi-information',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
            this.isButtonDisabled = false
            this.isLoading = false
        } else if (!this.initiatePayment) {
            // Initiate payment
            this.stripe
                .confirmCardSetup(this.stripeClientSecret, {
                    payment_method: {
                        card: this.elements.getElement('card'),
                    },
                })
                .then((result: any) => {
                    this.isButtonDisabled = true
                    if (result.error) {
                        this.isLoading = false
                        this.isButtonDisabled = false
                    }
                    if (result.setupIntent.status === 'succeeded') {
                        this.initiatePayment = result.setupIntent.payment_method
                        // Subscribe
                        this.submitSubscription(
                            result.setupIntent.payment_method
                        )
                        /* this.isButtonDisabled = false; */
                    }
                })
        } else {
            // Subscribe
            this.submitSubscription(this.initiatePayment)
            this.isLoading = true
        }
    }

    async getPlans() {
        const getPlans = await this.$api.plan.plans()
        if (getPlans) {
            this.plans = getPlans.data.data
            if (this.plans.length > 1) {
                this.isButtonDisabled = false
            }
        }
    }

    async getCoupons(code: string) {
        await this.$api.coupons
            .promo(code)
            .then((result) => {
                this.coupons = result.data
                this.getPrice()
            })
            .catch((error) => {
                console.log(error)
                this.promo = ''
                this.promoDisabled = false
                this.promoApply = false
                // Display subscription error message
                const val = {
                    text: this.$t('notification.promo.invalid'),
                    color: 'red',
                    icon: 'mdi-alert',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)
            })
    }

    getPrice() {
        if (this.coupons.amount_off) {
            this.price =
                this.plans[this.selectedPlan].amount - this.coupons.amount_off
        }
        if (this.coupons.percent_off) {
            this.price =
                this.plans[this.selectedPlan].amount *
                ((100 - this.coupons.percent_off) / 100)
        }
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }

        // Stripe
        const style = {
            base: {
                color: '#32325d',
                fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
                fontSmoothing: 'antialiased',
                fontSize: '14px',
                '::placeholder': {
                    color: '#aab7c4',
                },
            },
            invalid: {
                color: '#ff0000',
                iconColor: '#ff0000',
            },
        }

        this.elements = this.stripe.elements()
        // Create an instance of the card Element.
        this.card = this.elements.create('card', {
            style,
            hidePostalCode: true,
        })

        // Add an instance of the card Element into the `card-element` <div>.
       /*  if (document.getElementById('card-element')) {
            this.card.mount('#card-element')
            alert(1)
        } */
        
        // Handle real-time validation errors from the card Element.
        this.card.on('change', (event: any) => {

            const displayError = document.getElementById('card-errors')
            if (event.error) {
                this.formHasErrors = true
                this.isButtonDisabled = true
                displayError!.textContent = event.error.message
            } else {
                this.isButtonDisabled = false
                this.formHasErrors = false
                displayError!.textContent = ''
            }
        })
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)

        // Get plan
        this.getPlans()

        this.stripe = this.$stripe
    }
}
</script>
